searchNodes=[{"type":"module","title":"GitHubActions","doc":"A little tool to write GitHub actions in Elixir.","ref":"GitHubActions.html"},{"type":"function","title":"GitHubActions.run/1","doc":"Creates a GitHub actions workflow file.","ref":"GitHubActions.html#run/1"},{"type":"module","title":"GitHubActions.Config","doc":"A simple keyword-based configuration API. Examples This module is used to define the configuration for GitHubActions . import GitHubActions.Config config :linux , name : &quot;Ubuntu&quot; , runs_on : &quot;ubuntu-20.04&quot; config key : &quot;value&quot;","ref":"GitHubActions.Config.html"},{"type":"function","title":"GitHubActions.Config.config/0","doc":"Returns the configuration.","ref":"GitHubActions.Config.html#config/0"},{"type":"function","title":"GitHubActions.Config.config/1","doc":"Adds the given data to the configuration. Returns the configuration that was previously stored.","ref":"GitHubActions.Config.html#config/1"},{"type":"function","title":"GitHubActions.Config.config/2","doc":"Adds the given value to the configuration under the given key . Returns the configuration that was previously stored.","ref":"GitHubActions.Config.html#config/2"},{"type":"function","title":"GitHubActions.Config.fetch/1","doc":"Returns the value for key or keys in a tuple. If the configuration parameter does not exist, the function returns error . Examples iex&gt; Config . fetch ( :jobs ) { :ok , [ :linux ] } iex&gt; Config . fetch ( :foo ) :error iex&gt; Config . fetch ( [ :linux , :name ] ) { :ok , &quot;Ubuntu&quot; }","ref":"GitHubActions.Config.html#fetch/1"},{"type":"function","title":"GitHubActions.Config.fetch!/1","doc":"Returns the value for key or keys . Examples iex&gt; Config . fetch! ( :jobs ) [ :linux ] iex&gt; Config . fetch! ( [ :linux , :runs_on ] ) &quot;ubuntu-20.04&quot; iex&gt; Config . fetch! ( [ :linux , :foo ] ) ** (KeyError) key :foo not found in: [name: &quot;Ubuntu&quot;, runs_on: &quot;ubuntu-20.04&quot;]","ref":"GitHubActions.Config.html#fetch!/1"},{"type":"function","title":"GitHubActions.Config.get/2","doc":"Returns the value for key or keys . If the configuration parameter does not exist, the function returns the default value. Examples iex&gt; Config . get ( :jobs ) [ :linux ] iex&gt; Config . get ( :foo , :bar ) :bar iex&gt; Config . get ( [ :linux , :runs_on ] ) &quot;ubuntu-20.04&quot; iex&gt; Config . get ( :foo ) nil","ref":"GitHubActions.Config.html#get/2"},{"type":"function","title":"GitHubActions.Config.read/1","doc":"Reads the configuration from the given path .","ref":"GitHubActions.Config.html#read/1"},{"type":"type","title":"GitHubActions.Config.config/0","doc":"","ref":"GitHubActions.Config.html#t:config/0"},{"type":"type","title":"GitHubActions.Config.key/0","doc":"","ref":"GitHubActions.Config.html#t:key/0"},{"type":"type","title":"GitHubActions.Config.keys/0","doc":"","ref":"GitHubActions.Config.html#t:keys/0"},{"type":"type","title":"GitHubActions.Config.value/0","doc":"","ref":"GitHubActions.Config.html#t:value/0"},{"type":"module","title":"GitHubActions.Mix","doc":"Some functions for handling mix commands in workflows.","ref":"GitHubActions.Mix.html"},{"type":"function","title":"GitHubActions.Mix.mix/1","doc":"Generates a mix task. Examples iex&gt; mix ( :compile ) &quot;mix compile&quot;","ref":"GitHubActions.Mix.html#mix/1"},{"type":"function","title":"GitHubActions.Mix.mix/2","doc":"Generates a mix task with a sub task or options. The options will be converted to command line options. The &quot;special&quot; options :env and :os are used to set MIX_ENV . ## Examples iex&gt; mix ( :deps , :compile ) &quot;mix deps.compile&quot; iex&gt; mix ( :credo , strict : true ) &quot;mix credo --strict&quot; iex&gt; mix ( :credo , strict : false ) &quot;mix credo&quot; iex&gt; mix ( :sample , arg : 42 ) &quot;mix sample --arg 42&quot; iex&gt; mix ( :compile , env : :test ) &quot;MIX_ENV=test mix compile&quot; iex&gt; mix ( :compile , env : :test , os : :windows ) &quot;set MIX_ENV=test \\n mix compile \\n &quot; iex&gt; mix ( :compile , os : :windows ) &quot;mix compile&quot;","ref":"GitHubActions.Mix.html#mix/2"},{"type":"function","title":"GitHubActions.Mix.mix/3","doc":"Generates a mix task with a sub task or options. Examples iex&gt; mix ( :deps , :compile , warnings_as_errors : true ) &quot;mix deps.compile --warnings-as-errors&quot;","ref":"GitHubActions.Mix.html#mix/3"},{"type":"module","title":"GitHubActions.Project","doc":"A thin wrapper for Mix.Project to access the config .","ref":"GitHubActions.Project.html"},{"type":"function","title":"GitHubActions.Project.config/0","doc":"See Mix.Project.config/0 .","ref":"GitHubActions.Project.html#config/0"},{"type":"function","title":"GitHubActions.Project.elixir/0","doc":"Returns the Elixir version of the current project. Examples iex&gt; Project . elixir ( ) &quot;~&gt; 1.11&quot;","ref":"GitHubActions.Project.html#elixir/0"},{"type":"function","title":"GitHubActions.Project.fetch/1","doc":"Returns the value for given keys from the project config, in a tuple. Examples iex&gt; Project . fetch ( :app ) { :ok , :git_hub_actions } iex&gt; Project . fetch ( :unknown ) :error iex&gt; Project . fetch ( [ :test_coverage , :tool ] ) { :ok , ExCoveralls }","ref":"GitHubActions.Project.html#fetch/1"},{"type":"function","title":"GitHubActions.Project.fetch!/1","doc":"Returns the value for given keys from the project config, raises an error if keys are not available. Examples iex&gt; Project . fetch! ( :app ) :git_hub_actions iex&gt; Project . fetch! ( [ :test_coverage , :tool ] ) ExCoveralls","ref":"GitHubActions.Project.html#fetch!/1"},{"type":"function","title":"GitHubActions.Project.get/2","doc":"Returns the value for given keys from the project config. Examples iex&gt; Project . get ( :app ) :git_hub_actions iex&gt; Project . get ( :unknown , 42 ) 42 iex&gt; Project . get ( [ :test_coverage , :tool ] ) ExCoveralls","ref":"GitHubActions.Project.html#get/2"},{"type":"function","title":"GitHubActions.Project.has_dep?/1","doc":"Returns true if the given dep is part of the project. Examples iex&gt; Project . has_dep? ( :credo ) true iex&gt; Project . has_dep? ( :datix ) false","ref":"GitHubActions.Project.html#has_dep?/1"},{"type":"type","title":"GitHubActions.Project.default/0","doc":"","ref":"GitHubActions.Project.html#t:default/0"},{"type":"type","title":"GitHubActions.Project.key/0","doc":"","ref":"GitHubActions.Project.html#t:key/0"},{"type":"type","title":"GitHubActions.Project.keys/0","doc":"","ref":"GitHubActions.Project.html#t:keys/0"},{"type":"type","title":"GitHubActions.Project.value/0","doc":"","ref":"GitHubActions.Project.html#t:value/0"},{"type":"module","title":"GitHubActions.Sigils","doc":"This module defnies the sigils for GitHubActions .","ref":"GitHubActions.Sigils.html"},{"type":"function","title":"GitHubActions.Sigils.sigil_e/2","doc":"Handles the sigile ~e for GitHub actions expressions. Quotes the given string as a GitHub expression. Examples iex&gt; ~e[github.sha] &quot;${{ github.sha }}&quot;","ref":"GitHubActions.Sigils.html#sigil_e/2"},{"type":"module","title":"GitHubActions.Version","doc":"Functions for parsing and matching versions against requirements. A version is a string in a specific format or a GitHubActions.Version generated after parsing via GitHubActions.Version.parse/1 . This module is similar to Version except that minor and patch may be missing and pre are not supported. The Version module can also parse a range of versions. Examples iex&gt; &quot;2.0/2&quot; |&gt; Version . parse! ( ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;2.0&quot; , &quot;2.1&quot; , &quot;2.2&quot; ] iex&gt; &quot;1/3&quot; |&gt; Version . parse! ( ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ]","ref":"GitHubActions.Version.html"},{"type":"function","title":"GitHubActions.Version.compare/3","doc":"","ref":"GitHubActions.Version.html#compare/3"},{"type":"function","title":"GitHubActions.Version.match?/2","doc":"Checks if the given version matches the specification. Returns true if version satisfies requirement , false otherwise. Raises a Version.InvalidRequirementError exception if requirement is not parsable, or a GitHubActions.InvalidVersionError exception if version is not parsable. Examples iex&gt; Version . match? ( &quot;2.0&quot; , &quot;&gt; 1.0.0&quot; ) true iex&gt; Version . match? ( &quot;2.0&quot; , &quot;== 1.0.0&quot; ) false iex&gt; Version . match? ( &quot;2.2.6&quot; , &quot;~&gt; 2.2.2&quot; ) true iex&gt; Version . match? ( &quot;2.3&quot; , &quot;~&gt; 2.2&quot; ) true iex&gt; Version . match? ( &quot;2&quot; , &quot;~&gt; 2.1.2&quot; ) false iex&gt; Version . match? ( &quot;a.b.c&quot; , &quot;~&gt; 2.1.2&quot; ) ** (GitHubActions.InvalidVersionError) invalid version: &quot;a.b.c&quot; iex&gt; Version . match? ( &quot;2&quot; , &quot;~~~&gt; 2.1.2&quot; ) ** (Version.InvalidRequirementError) invalid requirement: &quot;~~~&gt; 2.1.2&quot;","ref":"GitHubActions.Version.html#match?/2"},{"type":"function","title":"GitHubActions.Version.parse/1","doc":"Parses a version string into a GitHubActions.Version struct. Examples iex&gt; { :ok , version } = Version . parse ( &quot;1.2&quot; ) iex&gt; version # Version &lt; 1.2 &gt; iex&gt; Version . parse ( &quot;1-2&quot; ) :error iex&gt; { :ok , [ v1 , v2 , v3 ] } = Version . parse ( &quot;2.2/4&quot; ) iex&gt; v1 # Version &lt; 2.2 &gt; iex&gt; v2 # Version &lt; 2.3 &gt; iex&gt; v3 # Version &lt; 2.4 &gt; iex&gt; { :ok , version } = Version . parse ( &quot;1.2&quot; ) iex&gt; { :ok , version } = Version . parse ( version ) iex&gt; version # Version &lt; 1.2 &gt;","ref":"GitHubActions.Version.html#parse/1"},{"type":"function","title":"GitHubActions.Version.parse!/1","doc":"Parses a version string into a GitHubActions.Version struct. If string is an invalid version, a GitHubActions.InvalidVersionError is raised. Examples iex&gt; Version . parse! ( &quot;1&quot; ) # Version &lt; 1 &gt; iex&gt; Version . parse! ( &quot;1.2&quot; ) # Version &lt; 1.2 &gt; iex&gt; Version . parse! ( &quot;1.2.3&quot; ) # Version &lt; 1.2 . 3 &gt; iex&gt; Version . parse! ( &quot;invalid&quot; ) ** (GitHubActions.InvalidVersionError) invalid version: &quot;invalid&quot;","ref":"GitHubActions.Version.html#parse!/1"},{"type":"function","title":"GitHubActions.Version.to_requirement/2","doc":"Returns the requiement for the given version and operator . Examples iex&gt; Version . to_requirement ( &quot;1&quot; , &quot;==&quot; ) &quot;== 1.0.0&quot; iex&gt; Version . to_requirement ( &quot;1.1&quot; , &quot;&gt;=&quot; ) &quot;&gt;= 1.1.0&quot; iex&gt; Version . to_requirement ( &quot;1.1&quot; , &quot;~&gt;&quot; ) &quot;~&gt; 1.1&quot; iex&gt; Version . to_requirement ( &quot;1.1.1&quot; , &quot;~&gt;&quot; ) &quot;~&gt; 1.1.1&quot;","ref":"GitHubActions.Version.html#to_requirement/2"},{"type":"type","title":"GitHubActions.Version.major/0","doc":"","ref":"GitHubActions.Version.html#t:major/0"},{"type":"type","title":"GitHubActions.Version.minor/0","doc":"","ref":"GitHubActions.Version.html#t:minor/0"},{"type":"type","title":"GitHubActions.Version.patch/0","doc":"","ref":"GitHubActions.Version.html#t:patch/0"},{"type":"type","title":"GitHubActions.Version.requirement/0","doc":"","ref":"GitHubActions.Version.html#t:requirement/0"},{"type":"type","title":"GitHubActions.Version.t/0","doc":"","ref":"GitHubActions.Version.html#t:t/0"},{"type":"type","title":"GitHubActions.Version.version/0","doc":"","ref":"GitHubActions.Version.html#t:version/0"},{"type":"module","title":"GitHubActions.Versions","doc":"Functions to select and filter lists and tables of versions. The list of versions can have the following two forms. A simple list: [ &quot;1&quot; , &quot;2.0&quot; , &quot;2.1&quot; , &quot;3&quot; , &quot;3.1&quot; , &quot;3.1.1&quot; ] A table as list of keyword lists with compatible versions: [ [ a : [ &quot;1.0.0&quot; ] , b : [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;1.2&quot; ] ] , [ a : [ &quot;2.0.0&quot; ] , b : [ &quot;1.2&quot; , &quot;2.0&quot; ] ] ]","ref":"GitHubActions.Versions.html"},{"type":"function","title":"GitHubActions.Versions.compatible/3","doc":"Returns the versions of key that are compatible with to . Examples iex&gt; otp = Versions . compatible ( :otp , elixir : &quot;1.6.6&quot; ) iex&gt; Enum . map ( otp , &amp; to_string / 1 ) [ &quot;19.0&quot; , &quot;19.1&quot; , &quot;19.2&quot; , &quot;19.3&quot; , &quot;20.0&quot; , &quot;20.1&quot; , &quot;20.2&quot; , &quot;20.3&quot; , &quot;21.0&quot; , &quot;21.1&quot; , &quot;21.2&quot; , &quot;21.3&quot; ] iex&gt; elixir = Versions . compatible ( :elixir , otp : &quot;20.3&quot; ) iex&gt; Enum . map ( elixir , &amp; to_string / 1 ) [ &quot;1.4.5&quot; , &quot;1.5.0&quot; , &quot;1.5.1&quot; , &quot;1.5.2&quot; , &quot;1.5.3&quot; , &quot;1.6.0&quot; , &quot;1.6.1&quot; , &quot;1.6.2&quot; , &quot;1.6.3&quot; , &quot;1.6.4&quot; , &quot;1.6.5&quot; , &quot;1.6.6&quot; , &quot;1.7.0&quot; , &quot;1.7.1&quot; , &quot;1.7.2&quot; , &quot;1.7.3&quot; , &quot;1.7.4&quot; , &quot;1.8.0&quot; , &quot;1.8.1&quot; , &quot;1.8.2&quot; , &quot;1.9.0&quot; , &quot;1.9.1&quot; , &quot;1.9.2&quot; , &quot;1.9.3&quot; , &quot;1.9.4&quot; ] iex&gt; :otp |&gt; Versions . compatible ( elixir : &quot;1.10.0&quot; ) |&gt; Enum . count ( ) 8 iex&gt; :otp |&gt; Versions . compatible ( elixir : &quot;1.10.0/4&quot; ) |&gt; Enum . count ( ) 12 iex&gt; :otp |&gt; Versions . compatible ( elixir : [ &quot;1.10.0/4&quot; , &quot;1.11.0/4&quot; ] ) |&gt; Enum . count ( ) 16 iex&gt; Versions . compatible ( [ ] , :otp , elixir : &quot;1.6.6&quot; ) ** (ArgumentError) compatible/3 expected a table of versions as first argument, got: []","ref":"GitHubActions.Versions.html#compatible/3"},{"type":"function","title":"GitHubActions.Versions.compatible?/2","doc":"Returns true if the given version1 is compatible to version2 . Examples iex&gt; Versions . compatible? ( elixir : &quot;1.12.3&quot; , otp : &quot;24.0&quot; ) true iex&gt; Versions . compatible? ( elixir : &quot;1.6.0&quot; , otp : &quot;24.0&quot; ) false iex&gt; versions = [ ...&gt; [ a : [ &quot;1.0.0&quot; ] , b : [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;1.2&quot; ] ] , ...&gt; [ a : [ &quot;2.0.0&quot; ] , b : [ &quot;1.2&quot; , &quot;2.0&quot; ] ] ...&gt; ] iex&gt; Versions . compatible? ( versions , a : &quot;1&quot; , b : &quot;1.2&quot; ) true iex&gt; Versions . compatible? ( versions , a : &quot;2&quot; , b : &quot;1.2&quot; ) true iex&gt; Versions . compatible? ( versions , a : &quot;2&quot; , b : &quot;1&quot; ) false iex&gt; Versions . compatible? ( [ ] , a : &quot;1&quot; , b : &quot;2&quot; ) ** (ArgumentError) compatible?/2 expected a table of versions as first argument, got: []","ref":"GitHubActions.Versions.html#compatible?/2"},{"type":"function","title":"GitHubActions.Versions.expand/1","doc":"Expands the given versions . Examples iex&gt; versions = Versions . expand ( [ &quot;1.0/2&quot; ] ) iex&gt; Enum . map ( versions , &amp; to_string / 1 ) [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;1.2&quot; ] iex&gt; versions = Versions . expand ( [ ...&gt; [ a : [ &quot;1.0/2&quot; ] , b : [ &quot;1.0.0/2&quot; ] ] , ...&gt; [ a : [ &quot;1.1.0/1&quot; ] , b : [ &quot;2.0.0/2&quot; ] ] ...&gt; ] ) iex&gt; versions |&gt; Enum . at ( 1 ) |&gt; Keyword . get ( :a ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;1.1.0&quot; , &quot;1.1.1&quot; ] iex&gt; versions |&gt; Enum . at ( 1 ) |&gt; Keyword . get ( :b ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;2.0.0&quot; , &quot;2.0.1&quot; , &quot;2.0.2&quot; ] iex&gt; Versions . expand ( [ :a ] ) ** (ArgumentError) expand/1 expected a list of versions, or table of versions got: [:a]","ref":"GitHubActions.Versions.html#expand/1"},{"type":"function","title":"GitHubActions.Versions.filter/2","doc":"Filters the list of versions by the given requirement . Examples iex&gt; versions = [ &quot;1&quot; , &quot;1.1.0/5&quot; , &quot;1.2.0/1&quot; , &quot;1.3&quot; , &quot;2.0/1&quot; ] iex&gt; Versions . filter ( versions , &quot;~&gt; 1.2&quot; ) [ % Version { major : 1 , minor : 2 , patch : 0 } , % Version { major : 1 , minor : 2 , patch : 1 } , % Version { major : 1 , minor : 3 } ] iex&gt; Versions . filter ( versions , &quot;&gt;= 1.3.0&quot; ) [ % Version { major : 1 , minor : 3 } , % Version { major : 2 , minor : 0 } , % Version { major : 2 , minor : 1 } ] iex&gt; Versions . filter ( [ :b , :a ] , &quot;&gt; 1.0.0&quot; ) ** (ArgumentError) filter/2 expected a list of versions, got: [:b, :a] iex&gt; Versions . filter ( [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] , &quot;&gt; 1&quot; ) ** (Version.InvalidRequirementError) invalid requirement: &quot;&gt; 1&quot;","ref":"GitHubActions.Versions.html#filter/2"},{"type":"function","title":"GitHubActions.Versions.from_config/0","doc":"Returns the versions from the config.","ref":"GitHubActions.Versions.html#from_config/0"},{"type":"function","title":"GitHubActions.Versions.get/2","doc":"Returns all versions for key from a list of compatible versions. This function raises a GitHubActions.InvalidVersionError for an invalid version. Examples iex&gt; versions = [ ...&gt; [ a : [ &quot;1.0.0&quot; ] , b : [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;1.2&quot; ] ] , ...&gt; [ a : [ &quot;2.0.0&quot; ] , b : [ &quot;1.2&quot; , &quot;2.0&quot; ] ] ...&gt; ] iex&gt; versions = Versions . get ( versions , :b ) iex&gt; hd versions # Version &lt; 1.0 &gt; iex&gt; Enum . map ( versions , &amp; to_string / 1 ) [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;1.2&quot; , &quot;2.0&quot; ] iex&gt; Versions . get ( [ a : &quot;1&quot; ] , :a ) ** (ArgumentError) get/2 expected a table of versions, got: [a: &quot;1&quot;]","ref":"GitHubActions.Versions.html#get/2"},{"type":"function","title":"GitHubActions.Versions.incompatible/2","doc":"Returns the incompatible versions between versions1 and versions2 . Examples iex&gt; versions = Versions . incompatible ( ...&gt; elixir : [ &quot;1.9.4&quot; , &quot;1.10.4&quot; , &quot;1.11.4&quot; , &quot;1.12.3&quot; ] , ...&gt; otp : [ &quot;21.3&quot; , &quot;22.3&quot; , &quot;23.3&quot; , &quot;24.0&quot; ] ...&gt; ) iex&gt; for [ { k1 , v1 } , { k2 , v2 } ] &lt;- versions do ...&gt; [ { k1 , to_string ( v1 ) } , { k2 , to_string ( v2 ) } ] ...&gt; end [ [ elixir : &quot;1.9.4&quot; , otp : &quot;23.3&quot; ] , [ elixir : &quot;1.9.4&quot; , otp : &quot;24.0&quot; ] , [ elixir : &quot;1.10.4&quot; , otp : &quot;24.0&quot; ] , [ elixir : &quot;1.12.3&quot; , otp : &quot;21.3&quot; ] ]","ref":"GitHubActions.Versions.html#incompatible/2"},{"type":"function","title":"GitHubActions.Versions.intersection?/2","doc":"Returns true if versions1 has an intersection with versions2 . Examples iex&gt; Versions . intersection? ( [ &quot;1.0.0/5&quot; ] , [ &quot;1.0.4/7&quot; ] ) true iex&gt; Versions . intersection? ( [ &quot;1.0.0/5&quot; ] , [ &quot;2.0.0/7&quot; ] ) false iex&gt; Versions . intersection? ( [ &quot;1.0.0/5&quot; ] , [ :a ] ) ** (ArgumentError) intersection?/2 expected two list of versions, got: [&quot;1.0.0/5&quot;], [:a]","ref":"GitHubActions.Versions.html#intersection?/2"},{"type":"function","title":"GitHubActions.Versions.latest/0","doc":"Returns the latest version from the configured versions list. Examples iex&gt; Config . config ( :versions , [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] ) iex&gt; Versions . latest ( ) # Version &lt; 1.1 . 3 &gt;","ref":"GitHubActions.Versions.html#latest/0"},{"type":"function","title":"GitHubActions.Versions.latest/1","doc":"Returns the latest version from the configured versions table by the given key or from the given versions list. Examples iex&gt; Versions . latest ( [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] ) # Version &lt; 1.1 . 3 &gt; iex&gt; Config . config ( :versions , [ ...&gt; [ a : [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] , b : [ &quot;2.0/5&quot; ] ] , ...&gt; [ a : [ &quot;1.2.0/1&quot; , &quot;1.3.0/4&quot; ] , b : [ &quot;3.0/5&quot; ] ] ...&gt; ] ) iex&gt; Versions . latest ( :a ) # Version &lt; 1.3 . 4 &gt; iex&gt; Versions . latest ( [ &quot;foo&quot; ] ) ** (GitHubActions.InvalidVersionError) invalid version: &quot;foo&quot; iex&gt; Versions . latest ( [ a : &quot;1&quot; ] ) ** (ArgumentError) latest/1 expected a list or table of versions or a key, got: [a: &quot;1&quot;] iex&gt; Versions . latest ( :elixir ) # Version &lt; 1.14 . 4 &gt; iex&gt; Versions . latest ( :otp ) # Version &lt; 26.0 &gt;","ref":"GitHubActions.Versions.html#latest/1"},{"type":"function","title":"GitHubActions.Versions.latest/2","doc":"Returns the latest version from a versions table by the given key . Examples iex&gt; Versions . latest ( [ ...&gt; [ a : [ &quot;1.0.0/2&quot; ] , b : [ &quot;1.0.0/3&quot; ] ] , ...&gt; [ a : [ &quot;1.1.0/3&quot; ] , b : [ &quot;1.1.0/4&quot; ] ] ...&gt; ] , :a ) # Version &lt; 1.1 . 3 &gt; iex&gt; Versions . latest ( [ a : &quot;1&quot; ] , :a ) ** (ArgumentError) latest/1 expected a table of versions, got: [a: &quot;1&quot;]","ref":"GitHubActions.Versions.html#latest/2"},{"type":"function","title":"GitHubActions.Versions.latest_major/0","doc":"Returns the latest major versions from the configured versions list. Examples iex&gt; Config . config ( :versions , [ &quot;1.0.0/2&quot; , &quot;1.1.0/4&quot; , &quot;2.0.0/3&quot; ] ) iex&gt; Versions . latest_major ( ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;1.1.4&quot; , &quot;2.0.3&quot; ]","ref":"GitHubActions.Versions.html#latest_major/0"},{"type":"function","title":"GitHubActions.Versions.latest_major/1","doc":"Returns the latest major versions from the configured versions table by the given key or from the given versions list. Examples iex&gt; major_versions = Versions . latest_major ( [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; , &quot;2.0.0/2&quot; ] ) iex&gt; Enum . map ( major_versions , &amp; to_string / 1 ) [ &quot;1.1.3&quot; , &quot;2.0.2&quot; ] iex&gt; Config . config ( :versions , [ ...&gt; [ a : [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] , b : [ &quot;2.0/5&quot; ] ] , ...&gt; [ a : [ &quot;2.2.0/1&quot; , &quot;2.3.0/4&quot; ] , b : [ &quot;3.0/5&quot; ] ] ...&gt; ] ) iex&gt; major_versions = Versions . latest_major ( :a ) iex&gt; Enum . map ( major_versions , &amp; to_string / 1 ) [ &quot;1.1.3&quot; , &quot;2.3.4&quot; ] iex&gt; Versions . latest_major ( [ &quot;foo&quot; ] ) ** (GitHubActions.InvalidVersionError) invalid version: &quot;foo&quot; iex&gt; Versions . latest_major ( [ a : &quot;1&quot; ] ) ** (ArgumentError) latest_major/1 expected a list or table of versions or a key, got: [a: &quot;1&quot;] iex&gt; major_versions = Versions . latest_major ( :elixir ) iex&gt; Enum . map ( major_versions , &amp; to_string / 1 ) [ &quot;1.14.4&quot; ] iex&gt; major_versions = Versions . latest_major ( :otp ) iex&gt; Enum . map ( major_versions , &amp; to_string / 1 ) [ &quot;17.5&quot; , &quot;18.3&quot; , &quot;19.3&quot; , &quot;20.3&quot; , &quot;21.3&quot; , &quot;22.3&quot; , &quot;23.3&quot; , &quot;24.3&quot; , &quot;25.3&quot; , &quot;26.0&quot; ]","ref":"GitHubActions.Versions.html#latest_major/1"},{"type":"function","title":"GitHubActions.Versions.latest_major/2","doc":"Returns the latest major versions from a versions table by the given key . Examples iex&gt; major_versions = Versions . latest_major ( [ ...&gt; [ a : [ &quot;1.0.0/2&quot; ] , b : [ &quot;1.0.0/3&quot; ] ] , ...&gt; [ a : [ &quot;2.0.0/3&quot; ] , b : [ &quot;2.0.0/4&quot; ] ] ...&gt; ] , :a ) iex&gt; Enum . map ( major_versions , &amp; to_string / 1 ) [ &quot;1.0.2&quot; , &quot;2.0.3&quot; ] iex&gt; Versions . latest_major ( [ a : &quot;1&quot; ] , :a ) ** (ArgumentError) latest_major/1 expected a table of versions, got: [a: &quot;1&quot;]","ref":"GitHubActions.Versions.html#latest_major/2"},{"type":"function","title":"GitHubActions.Versions.latest_minor/0","doc":"Returns the latest minor versions from the configured versions list. Examples iex&gt; Config . config ( :versions , [ &quot;1.0.0/2&quot; , &quot;1.1.0/4&quot; , &quot;2.0.0/3&quot; ] ) iex&gt; Versions . latest_minor ( ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;1.0.2&quot; , &quot;1.1.4&quot; , &quot;2.0.3&quot; ]","ref":"GitHubActions.Versions.html#latest_minor/0"},{"type":"function","title":"GitHubActions.Versions.latest_minor/1","doc":"Returns the latest minor versions from the configured versions table by the given key or from the given versions list. Examples iex&gt; minor_versions = Versions . latest_minor ( [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] ) iex&gt; Enum . map ( minor_versions , &amp; to_string / 1 ) [ &quot;1.0.2&quot; , &quot;1.1.3&quot; ] iex&gt; Config . config ( :versions , [ ...&gt; [ a : [ &quot;1.0.0/2&quot; , &quot;1.1.0/3&quot; ] , b : [ &quot;2.0/5&quot; ] ] , ...&gt; [ a : [ &quot;1.2.0/1&quot; , &quot;1.3.0/4&quot; ] , b : [ &quot;3.0/5&quot; ] ] ...&gt; ] ) iex&gt; minor_versions = Versions . latest_minor ( :a ) iex&gt; Enum . map ( minor_versions , &amp; to_string / 1 ) [ &quot;1.0.2&quot; , &quot;1.1.3&quot; , &quot;1.2.1&quot; , &quot;1.3.4&quot; ] iex&gt; Versions . latest_minor ( [ &quot;foo&quot; ] ) ** (GitHubActions.InvalidVersionError) invalid version: &quot;foo&quot; iex&gt; Versions . latest_minor ( [ a : &quot;1&quot; ] ) ** (ArgumentError) latest_minor/1 expected a list or table of versions or a key, got: [a: &quot;1&quot;] iex&gt; minor_versions = Versions . latest_minor ( :elixir ) iex&gt; Enum . map ( minor_versions , &amp; to_string / 1 ) [ &quot;1.0.5&quot; , &quot;1.1.1&quot; , &quot;1.2.6&quot; , &quot;1.3.4&quot; , &quot;1.4.5&quot; , &quot;1.5.3&quot; , &quot;1.6.6&quot; , &quot;1.7.4&quot; , &quot;1.8.2&quot; , &quot;1.9.4&quot; , &quot;1.10.4&quot; , &quot;1.11.4&quot; , &quot;1.12.3&quot; , &quot;1.13.4&quot; , &quot;1.14.4&quot; ] iex&gt; minor_versions = Versions . latest_minor ( :otp ) iex&gt; Enum . map ( minor_versions , &amp; to_string / 1 ) [ &quot;17.0&quot; , &quot;17.1&quot; , &quot;17.2&quot; , &quot;17.3&quot; , &quot;17.4&quot; , &quot;17.5&quot; , &quot;18.0&quot; , &quot;18.1&quot; , &quot;18.2&quot; , &quot;18.3&quot; , &quot;19.0&quot; , &quot;19.1&quot; , &quot;19.2&quot; , &quot;19.3&quot; , &quot;20.0&quot; , &quot;20.1&quot; , &quot;20.2&quot; , &quot;20.3&quot; , &quot;21.0&quot; , &quot;21.1&quot; , &quot;21.2&quot; , &quot;21.3&quot; , &quot;22.0&quot; , &quot;22.1&quot; , &quot;22.2&quot; , &quot;22.3&quot; , &quot;23.0&quot; , &quot;23.1&quot; , &quot;23.2&quot; , &quot;23.3&quot; , &quot;24.0&quot; , &quot;24.1&quot; , &quot;24.2&quot; , &quot;24.3&quot; , &quot;25.0&quot; , &quot;25.1&quot; , &quot;25.2&quot; , &quot;25.3&quot; , &quot;26.0&quot; ]","ref":"GitHubActions.Versions.html#latest_minor/1"},{"type":"function","title":"GitHubActions.Versions.latest_minor/2","doc":"Returns the latest minor versions from a versions table by the given key . Examples iex&gt; minor_versions = Versions . latest_minor ( [ ...&gt; [ a : [ &quot;1.0.0/2&quot; ] , b : [ &quot;1.0.0/3&quot; ] ] , ...&gt; [ a : [ &quot;1.1.0/3&quot; ] , b : [ &quot;1.1.0/4&quot; ] ] ...&gt; ] , :a ) iex&gt; Enum . map ( minor_versions , &amp; to_string / 1 ) [ &quot;1.0.2&quot; , &quot;1.1.3&quot; ] iex&gt; Versions . latest_minor ( [ a : &quot;1&quot; ] , :a ) ** (ArgumentError) latest_minor/1 expected a table of versions, got: [a: &quot;1&quot;]","ref":"GitHubActions.Versions.html#latest_minor/2"},{"type":"function","title":"GitHubActions.Versions.matrix/2","doc":"Returns the versions matrix for the given requirements. Examples iex&gt; matrix = Versions . matrix ( elixir : &quot;&gt;= 1.9.0&quot; , otp : &quot;&gt;= 22.0.0&quot; ) iex&gt; Enum . map ( matrix [ :elixir ] , &amp; to_string / 1 ) [ &quot;1.9.4&quot; , &quot;1.10.4&quot; , &quot;1.11.4&quot; , &quot;1.12.3&quot; , &quot;1.13.4&quot; , &quot;1.14.4&quot; ] iex&gt; Enum . map ( matrix [ :otp ] , &amp; to_string / 1 ) [ &quot;22.3&quot; , &quot;23.3&quot; , &quot;24.3&quot; , &quot;25.3&quot; , &quot;26.0&quot; ] iex&gt; for [ { k1 , v1 } , { k2 , v2 } ] &lt;- matrix [ :exclude ] do ...&gt; [ { k1 , to_string ( v1 ) } , { k2 , to_string ( v2 ) } ] ...&gt; end [ [ elixir : &quot;1.9.4&quot; , otp : &quot;23.3&quot; ] , [ elixir : &quot;1.9.4&quot; , otp : &quot;24.3&quot; ] , [ elixir : &quot;1.9.4&quot; , otp : &quot;25.3&quot; ] , [ elixir : &quot;1.9.4&quot; , otp : &quot;26.0&quot; ] , [ elixir : &quot;1.10.4&quot; , otp : &quot;24.3&quot; ] , [ elixir : &quot;1.10.4&quot; , otp : &quot;25.3&quot; ] , [ elixir : &quot;1.10.4&quot; , otp : &quot;26.0&quot; ] , [ elixir : &quot;1.11.4&quot; , otp : &quot;25.3&quot; ] , [ elixir : &quot;1.11.4&quot; , otp : &quot;26.0&quot; ] , [ elixir : &quot;1.12.3&quot; , otp : &quot;25.3&quot; ] , [ elixir : &quot;1.12.3&quot; , otp : &quot;26.0&quot; ] , [ elixir : &quot;1.13.4&quot; , otp : &quot;26.0&quot; ] , [ elixir : &quot;1.14.4&quot; , otp : &quot;22.3&quot; ] ] iex&gt; Versions . matrix ( [ ] , elixir : &quot;&gt;= 1.9.0&quot; , otp : &quot;&gt;= 22.0.0&quot; ) ** (ArgumentError) matrix/1 expected a table of versions as first argument, got: []","ref":"GitHubActions.Versions.html#matrix/2"},{"type":"function","title":"GitHubActions.Versions.member?/2","doc":"Returns true if versions contains the given version . Examples iex&gt; versions = [ &quot;1.0.0&quot; , &quot;1.1.0&quot; , &quot;1.1.1&quot; ] iex&gt; Versions . member? ( versions , &quot;1.1&quot; ) true iex&gt; Versions . member? ( versions , &quot;1.0.1&quot; ) false iex&gt; Versions . member? ( [ a : &quot;1&quot; ] , &quot;1.0.0&quot; ) ** (ArgumentError) member?/2 expected a list of versions, got: [a: &quot;1&quot;]","ref":"GitHubActions.Versions.html#member?/2"},{"type":"function","title":"GitHubActions.Versions.sort/1","doc":"Sorts the given versions . Examples iex&gt; versions = [ &quot;1.1&quot; , &quot;11.1&quot; , &quot;1.0&quot; , &quot;2.1&quot; , &quot;2.0.1&quot; , &quot;2.0.0&quot; ] iex&gt; versions = Versions . sort ( versions ) iex&gt; Enum . map ( versions , &amp; to_string / 1 ) [ &quot;1.0&quot; , &quot;1.1&quot; , &quot;2.0.0&quot; , &quot;2.0.1&quot; , &quot;2.1&quot; , &quot;11.1&quot; ] iex&gt; Versions . sort ( [ a : [ &quot;1&quot; , &quot;2&quot; ] ] ) ** (ArgumentError) sort/2 expected a list or table of versions, got: [a: [&quot;1&quot;, &quot;2&quot;]]","ref":"GitHubActions.Versions.html#sort/1"},{"type":"function","title":"GitHubActions.Versions.uniq/1","doc":"Removes all duplicated versions. Examples iex&gt; versions = Versions . expand ( [ &quot;1.0.0/4&quot; , &quot;1.0.2/5&quot; ] ) iex&gt; versions |&gt; Versions . uniq ( ) |&gt; Enum . map ( &amp; to_string / 1 ) [ &quot;1.0.0&quot; , &quot;1.0.1&quot; , &quot;1.0.2&quot; , &quot;1.0.3&quot; , &quot;1.0.4&quot; , &quot;1.0.5&quot; ] iex&gt; Versions . uniq ( [ :a ] ) ** (ArgumentError) uniq/1 expected a list or table of versions, got: [:a]","ref":"GitHubActions.Versions.html#uniq/1"},{"type":"type","title":"GitHubActions.Versions.key/0","doc":"","ref":"GitHubActions.Versions.html#t:key/0"},{"type":"type","title":"GitHubActions.Versions.versions/0","doc":"","ref":"GitHubActions.Versions.html#t:versions/0"},{"type":"type","title":"GitHubActions.Versions.versions_list/0","doc":"","ref":"GitHubActions.Versions.html#t:versions_list/0"},{"type":"type","title":"GitHubActions.Versions.versions_table/0","doc":"","ref":"GitHubActions.Versions.html#t:versions_table/0"},{"type":"module","title":"GitHubActions.Workflow","doc":"The GitHubActions.Workflow is used to create a GitHub actions workflow. defmodule Minimal do use GitHubActions.Workflow def workflow do [ name : &quot;CI&quot; ] end end The workflow module must define the workflow/0 function. This function returns a nested data structure that will be translated in a yml-file. The line use GitHubActions.Workflow imports GitHubActions.Workflow , GitHubActions.Mix and GitHubActions.Sigils and adds the aliases GitHubActions.Config , GitHubActions.Project and GitHubActions.Versions . List entries with the value :skip are not taken over. Key-value pairs with a value of :skip are also not part of the resulting data structure. With :skip, you can handle optional parts in a workflow script. defmodule Simple do use GitHubActions.Workflow def workflow do [ name : &quot;CI&quot; , jobs : [ linux : linux ( ) , os2 : os2 ( ) ] ] end defp linux do job ( :linux , name : &quot;Test on \#{ Config . fetch! ( [ :linux , :name ] ) } &quot; , runs_on : Config . fetch! ( [ :linux , :runs_on ] ) ) end defp os2 do job ( :linux , name : &quot;Test on \#{ Config . fetch! ( [ :os2 , :name ] ) } &quot; , runs_on : Config . fetch! ( [ :os2 , :runs_on ] ) ) end defp job ( os , cofig ) do case :jobs |&gt; Config . get ( [ ] ) |&gt; Enum . member? ( os ) do true -&gt; config false -&gt; :skip end end end It is also possible to add steps when a dependency is available in the current project. defmodule Simple do use GitHubActions.Workflow def workflow do [ name : &quot;CI&quot; , jobs : [ linux : linux ( ) ] ] end defp linux do name : &quot;Test on \#{ Config . fetch! ( [ :linux , :name ] ) } &quot; , runs_on : Config . fetch! ( [ :linux , :runs_on ] ) steps : [ checkout ( ) , check_code_format ( ) , lint_code ( ) ] end defp checkout do [ name : &quot;Checkout&quot; , uses : &quot;actions/checkout@v3&quot; ] end defp lint_code do case Project . has_dep? ( :credo ) do false -&gt; :skip true -&gt; [ name : &quot;Lint code&quot; , run : mix ( :credo , strict : true , env : :test ) ] end end defp check_code_format do case Config . get ( :check_code_format , true ) do false -&gt; :skip true -&gt; [ name : &quot;Check code format&quot; , run : mix ( :format , check_formatted : true , env : :test ) ] end end end","ref":"GitHubActions.Workflow.html"},{"type":"function","title":"GitHubActions.Workflow.eval/1","doc":"Evaluates a workflow script and returns the workflow data structure.","ref":"GitHubActions.Workflow.html#eval/1"},{"type":"task","title":"Mix.Tasks.Gha","doc":"Creates a GitHub actions file. See Usage and Defaults for more information. Command line options --config , -c - specifies the config file --output , -o - specifites the output file, defaults to .github/workflows/ci.yml --workflow , -w - specifies the workflow script","ref":"Mix.Tasks.Gha.html"},{"type":"task","title":"Mix.Tasks.Gha.Config","doc":"Creates a GitHubActions directory with config and default workflow. The config file gets the name config.exs and the default workflow gets the name defaults.exs . Command line options --gen-global - creates ~/.gha --gen-local - creates .gha","ref":"Mix.Tasks.Gha.Config.html"},{"type":"exception","title":"GitHubActions.Error","doc":"","ref":"GitHubActions.Error.html"},{"type":"exception","title":"GitHubActions.InvalidVersionError","doc":"","ref":"GitHubActions.InvalidVersionError.html"},{"type":"extras","title":"Usage","doc":"GitHubActions is a little tool to write GitHub actions in Elixir. This lib is an early beta and is currently experimental.","ref":"usage.html"},{"type":"extras","title":"Usage - Install","doc":"GitHubActions can be installed as an archive. $&gt; mix archive.install hex git_hub_actions Or, as a dependency. def deps do [ { :git_hub_actions , &quot;~&gt; 0.1&quot; , only : :dev } ] end","ref":"usage.html#install"},{"type":"extras","title":"Usage - Create a workflow yml","doc":"GitHubActions comes with some default settings to create a workflow yml. You can run mix gha in a project root directory to create .github/workflows/ci.yml . $&gt; mix gha * creating .github/workflows/ci.yml The defaults are piv/config.exs and piv/default.exs .","ref":"usage.html#create-a-workflow-yml"},{"type":"extras","title":"Usage - Custom workflow and config","doc":"See GitHubActions.workflow for how to write a workflow script. The mix task gha comes with the options --workflow and --config to use custom scripts. The config will be merged into the default config. It is also possible to setup a ./.gha directory in your home directory or in the project root directory. The mix task gha.config with the options --gen-global and --gen-local will copy the defaults to the related location. The configuration will be read from priv/config.exs and afterward updated by ~/.gha/config.exs and then by ./.gha/config.exs . GitHubActions will search the workflow script in the order ./.gha/default.exs , ~/.gha/default.exs and priv/default.exs . The name of the default script can be changed in the configuration und input: [default: &quot;my_workflow.exs&quot;] .","ref":"usage.html#custom-workflow-and-config"},{"type":"extras","title":"Defaults","doc":"The defaults create a workflow file that runs on ubuntu-20.04 . The matrix is created with the setting of elixir from the relevant project and the OTP versions &gt;= 20. The linux job gets the following steps: checkout setup_elixir , using erlef/setup-elixir@v1 restore(:deps) , can be suppressed by config restore(:_build) , can be suppressed by config restore(:dialyxir) , when :dialyxir is part of the dependencies, can be suppressed by config get_deps compile_deps compile , with --warnings-as-errors check_code_format , can be suppressed by config, executes only for the latest Elixir/OTP version lint_code , when :credo is part of the dependencies, executes only for the latest Elixir/OTP version run_tests dialyxir , when :dialyxir is part of the dependencies The workflow script also contains jobs for macOS and Windows . To activate these jobs, set config :jobs, [:linux, :macos, :windows] in the config. The jobs for macOS and Windows use just the latest Elixir/OTP version.","ref":"defaults.html"},{"type":"extras","title":"Defaults - config.exs","doc":"import GitHubActions.Config config :output , comment : true , path : &quot;.github/workflows&quot; , file : &quot;ci.yml&quot; config :input , default : &quot;default.exs&quot; config :steps , refresh : true , check_code_format : true , dialyxir : true , coveralls : :github config :mix , env : nil # Specifies for which OSs jobs are generated. Possible values :linux, # :windows and :macos. config :jobs , [ :linux ] # Specifies the linux distribution. config :linux , name : &quot;Ubuntu&quot; , runs_on : &quot;ubuntu-20.04&quot; # Specifies the macos version. config :macos , name : &quot;macOS&quot; , runs_on : &quot;macos-latest&quot; # Specifies the windows version. config :windows , name : &quot;Windows&quot; , runs_on : &quot;windows-latest&quot; config versions : [ [ otp : [ &quot;17.0/5&quot; ] , elixir : [ &quot;1.0.0/5&quot; , &quot;1.1.0/1&quot; ] ] , [ otp : [ &quot;18.0/3&quot; ] , elixir : [ &quot;1.0.5&quot; , &quot;1.1.0/1&quot; , &quot;1.2.0/6&quot; , &quot;1.3.0/4&quot; , &quot;1.4.0/5&quot; , &quot;1.5.0/3&quot; ] ] , [ otp : [ &quot;19.0/3&quot; ] , elixir : [ &quot;1.2.6&quot; , &quot;1.3.0/4&quot; , &quot;1.4.0/5&quot; , &quot;1.5.0/3&quot; , &quot;1.6.0/6&quot; , &quot;1.7.0/4&quot; ] ] , [ otp : [ &quot;20.0/3&quot; ] , elixir : [ &quot;1.4.5&quot; , &quot;1.5.0/3&quot; , &quot;1.6.0/6&quot; , &quot;1.7.0/4&quot; , &quot;1.8.0/2&quot; , &quot;1.9.0/4&quot; ] ] , [ otp : [ &quot;21.0/3&quot; ] , elixir : [ &quot;1.6.6&quot; , &quot;1.7.0/4&quot; , &quot;1.8.0/2&quot; , &quot;1.9.0/4&quot; , &quot;1.10.0/4&quot; , &quot;1.11.0/4&quot; ] ] , [ otp : [ &quot;22.0/3&quot; ] , elixir : [ &quot;1.7.0/4&quot; , &quot;1.8.0/2&quot; , &quot;1.9.0/4&quot; , &quot;1.10.0/4&quot; , &quot;1.11.0/4&quot; , &quot;1.12.0/2&quot; ] ] , [ otp : [ &quot;23.0/3&quot; ] , elixir : [ &quot;1.10.3/4&quot; , &quot;1.11.0/4&quot; , &quot;1.12.0/2&quot; ] ] , [ otp : [ &quot;24.0/1&quot; ] , elixir : [ &quot;1.11.4&quot; , &quot;1.12.0/2&quot; ] ] ]","ref":"defaults.html#config-exs"},{"type":"extras","title":"Defaults - default.exs","doc":"defmodule GitHubActions.Default do use GitHubActions.Workflow def workflow do [ name : &quot;CI&quot; , env : [ GITHUB_TOKEN : ~e[secrets.GITHUB_TOKEN] ] , on : ~w(pull_request push) , jobs : [ linux : job ( :linux ) , windows : job ( :windows ) , macos : job ( :macos ) ] ] end defp job ( :linux = os ) do job ( os , name : &quot;&quot;&quot; Test on \#{ Config . get ( [ os , :name ] ) } ( \\ Elixir \#{ ~e[matrix.elixir] } , \\ OTP \#{ ~e[matrix.otp] } ) \\ &quot;&quot;&quot; , runs_on : Config . get ( [ os , :runs_on ] ) , strategy : [ matrix : Versions . matrix ( elixir : Project . elixir ( ) , otp : &quot;&gt; 20.0.0&quot; ) ] , steps : [ checkout ( ) , setup_elixir ( os ) , restore ( :deps ) , restore ( :_build ) , restore ( :dialyxir ) , get_deps ( ) , compile_deps ( os ) , compile ( os ) , check_code_format ( ) , lint_code ( ) , run_tests ( os ) , dialyxir ( ) ] ) end defp job ( :windows = os ) do job ( os , name : &quot;Test on \#{ Config . get ( [ os , :name ] ) } &quot; , runs_on : Config . get ( [ os , :runs_on ] ) , steps : [ checkout ( ) , restore ( :chocolatey ) , setup_elixir ( os ) , install_hex ( ) , install_rebar ( ) , get_deps ( ) , compile_deps ( os ) , compile ( os ) , run_tests ( os ) ] ) end defp job ( :macos = os ) do job ( os , name : &quot;Test on \#{ Config . get ( [ os , :name ] ) } &quot; , runs_on : Config . get ( [ os , :runs_on ] ) , steps : [ checkout ( ) , setup_elixir ( os ) , install_hex ( ) , install_rebar ( ) , restore ( :deps ) , restore ( :_build ) , get_deps ( ) , compile_deps ( os ) , compile ( os ) , run_tests ( os ) ] ) end defp job ( os , config ) do case member? ( :jobs , os ) do true -&gt; config false -&gt; :skip end end defp checkout do [ name : &quot;Checkout&quot; , uses : &quot;actions/checkout@v3&quot; ] end defp setup_elixir ( :linux ) do [ name : &quot;Setup Elixir&quot; , uses : &quot;erlef/setup-elixir@v1&quot; , with : [ elixir_version : ~e[matrix.elixir] , otp_version : ~e[matrix.otp] ] ] end defp setup_elixir ( :macos ) do [ name : &quot;Setup Elixir&quot; , run : &quot;brew install elixir&quot; ] end defp setup_elixir ( :windows ) do echo = ~S(echo &quot;C:\\ProgramData\\chocolatey\\lib\\Elixir\\bin;C:\\ProgramData\\chocolatey\\bin&quot;) path = ~S(Out-File -FilePath $env:GITHUB_PATH -Encoding utf8 -Append) [ name : &quot;Setup Elixir&quot; , run : &quot;&quot;&quot; cinst elixir --no-progress \#{ echo } | \#{ path } &quot;&quot;&quot; ] end defp install_hex do [ name : &quot;Install hex&quot; , run : mix ( :local , :hex , force : true ) ] end defp install_rebar do [ name : &quot;Install rebar&quot; , run : mix ( :local , :rebar , force : true ) ] end defp restore ( :chocolatey ) do [ name : &quot;Restore chocolatey&quot; , uses : &quot;actions/cache@v3&quot; , with : [ path : ~S&quot;C:\\Users\\runneradmin\\AppData\\Local\\Temp\\chocolatey&quot; , key : &quot; \#{ ~e[runner.os] } -chocolatey- \#{ ~e[github.sha] } &quot; , restore_keys : &quot;&quot;&quot; \#{ ~e[runner.os] } -chocolatey- &quot;&quot;&quot; ] ] end defp restore ( :dialyxir ) do case Project . has_dep? ( :dialyxir ) and Config . get ( [ :steps , :dialyxir ] ) do false -&gt; :skip true -&gt; case Project . fetch ( [ :dialyzer , :plt_file ] ) do :error -&gt; :skip { :ok , { _ , file } } -&gt; file |&gt; Path . dirname ( ) |&gt; restore ( ) end end end defp restore ( path ) do case Config . fetch! ( [ :steps , :refresh ] ) do false -&gt; :skip true -&gt; [ name : &quot;Restore \#{ path } &quot; , uses : &quot;actions/cache@v3&quot; , with : [ path : &quot; \#{ path } &quot; , key : key ( path ) ] ] end end defp get_deps do [ name : &quot;Get dependencies&quot; , run : mix ( :deps , :get ) ] end defp compile_deps ( os ) do [ name : &quot;Compile dependencies&quot; , run : mix ( :deps , :compile , env : :test , os : os ) ] end defp compile ( os ) do [ name : &quot;Compile project&quot; , run : mix ( :compile , warnings_as_errors : true , env : :test , os : os ) ] end defp check_code_format do case Config . get ( :check_code_format , true ) do false -&gt; :skip true -&gt; [ name : &quot;Check code format&quot; , if : ~e&quot;&quot;&quot; contains(matrix.elixir, &#39; \#{ Versions . latest ( :elixir ) } &#39;) &amp;&amp; \\ contains(matrix.otp, &#39; \#{ Versions . latest ( :otp ) } &#39;) \\ &quot;&quot;&quot; , run : mix ( :format , check_formatted : true , env : :test ) ] end end defp lint_code do case Project . has_dep? ( :credo ) do false -&gt; :skip true -&gt; [ name : &quot;Lint code&quot; , if : ~e&quot;&quot;&quot; contains(matrix.elixir, &#39; \#{ Versions . latest ( :elixir ) } &#39;) &amp;&amp; \\ contains(matrix.otp, &#39; \#{ Versions . latest ( :otp ) } &#39;) \\ &quot;&quot;&quot; , run : mix ( :credo , strict : true , env : :test ) ] end end defp run_tests ( :windows ) do [ name : &quot;Run tests&quot; , run : mix ( :test ) ] end defp run_tests ( _nix ) do case Project . has_dep? ( :excoveralls ) do true -&gt; [ name : &quot;Run tests with coverage&quot; , run : mix ( :coveralls , Config . get ( [ :steps , :coveralls ] ) , env : :test ) ] false -&gt; [ name : &quot;Run tests&quot; , run : mix ( :test ) ] end end defp dialyxir do case Project . has_dep? ( :dialyxir ) do false -&gt; :skip true -&gt; [ name : &quot;Static code analysis&quot; , run : mix ( :dialyzer ) ] end end defp key ( key ) do os = ~e[runner.os] elixir = ~e[matrix.elixir] otp = ~e[matrix.otp] lock = ~e[hashFiles(format(&#39;{0}{1}&#39;, github.workspace, &#39;/mix.lock&#39;))] &quot; \#{ key } - \#{ os } - \#{ elixir } - \#{ otp } - \#{ lock } &quot; end defp member? ( key , value ) , do : key |&gt; Config . get ( ) |&gt; Enum . member? ( value ) end","ref":"defaults.html#default-exs"}]